"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.analyzeSvelteComponent = void 0;
const type_analyzer_1 = require("@previewjs/type-analyzer");
const typescript_1 = __importDefault(require("typescript"));
function analyzeSvelteComponent(typeAnalyzer, filePath) {
    var _a;
    const resolver = typeAnalyzer.analyze([filePath]);
    const sourceFile = resolver.sourceFile(filePath);
    const propsTypeFields = {};
    let collected = {};
    for (const statement of (sourceFile === null || sourceFile === void 0 ? void 0 : sourceFile.statements) || []) {
        if (typescript_1.default.isVariableStatement(statement) &&
            ((_a = statement.modifiers) === null || _a === void 0 ? void 0 : _a.find((m) => m.kind === typescript_1.default.SyntaxKind.ExportKeyword))) {
            for (const declaration of statement.declarationList.declarations) {
                if (!typescript_1.default.isIdentifier(declaration.name)) {
                    continue;
                }
                const { type: fieldType, collected: fieldCollected } = resolver.resolveType(resolver.checker.getTypeAtLocation(declaration.name));
                propsTypeFields[declaration.name.text] = fieldType;
                collected = { ...collected, ...fieldCollected };
            }
        }
    }
    return {
        propsType: (0, type_analyzer_1.objectType)(propsTypeFields),
        types: collected,
    };
}
exports.analyzeSvelteComponent = analyzeSvelteComponent;
